﻿
using System.ComponentModel;
using System.Collections;
using System.Collections.ObjectModel;
using System.Collections.Generic;
namespace TreeViewInComboBox
{
	public class DataItem : INotifyPropertyChanged
	{
		private bool isSelected;
		private bool isExpanded;

		public event PropertyChangedEventHandler PropertyChanged;

		public DataItem()
		{
			this.Children = new ObservableCollection<DataItem>();
		}

		public bool IsExpanded
		{
			get
			{
				return this.isExpanded;
			}
			set
			{
				if (this.isExpanded != value)
				{
					this.isExpanded = value;
					if (this.isExpanded && this.Parent != null)
					{
						this.Parent.IsExpanded = true;
					}
					this.OnPropertyChanged("IsExpanded");
				}
			}
		}

		public bool IsSelected
		{
			get
			{
				return this.isSelected;
			}
			set
			{
				if (this.isSelected != value)
				{
					this.isSelected = value;
					if (this.isSelected)
					{
						this.IsExpanded = true;
					}
					this.OnPropertyChanged("IsSelected");
				}
			}
		}

		public DataItem Parent { get; set; }

		public string Text { get; set; }

		public IList<DataItem> Children { get; set; }

		protected void OnPropertyChanged(string propertyName)
		{
			if (this.PropertyChanged != null)
			{
				this.PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
			}
		}
	}
}