﻿using System.Windows.Controls;
using System.Collections.ObjectModel;
using System;
using Telerik.Windows;
using Telerik.Windows.Controls;
using System.Windows;
using Telerik.Windows.Controls;
using System.Windows.Controls.Primitives;
using System.ComponentModel;
using System.Linq;

namespace TreeViewInComboBox
{
	public partial class MainPage : UserControl, INotifyPropertyChanged
	{
		ObservableCollection<DataItem> items;

		public MainPage()
		{
			InitializeComponent();

			items = new ObservableCollection<DataItem>();

			items.Add(new DataItem()
			{
				Text = "Child 1",
				Children =
					{
						new DataItem() { Text = "Child 1.1",
							Children = Enumerable.Range(1, 2000).Select(i => new DataItem(){ Text = String.Format("Child 1.1.{0}", i) }).ToList(),
						},
						new DataItem() { Text = "Child 1.2" },
						new DataItem() { Text = "Child 1.3" }
					}
			});
			items.Add(new DataItem()
			{
				Text = "Child 2",
				Children =
					{
						new DataItem() { Text = "Child 2.1" },
						new DataItem() { Text = "Child 2.2" },
						new DataItem() { Text = "Child 2.3" }
					}
			});
			items.Add(new DataItem()
			{
				Text = "Child 3",
				Children =
					{
						new DataItem() { Text = "Child 3.1" },
						new DataItem() { Text = "Child 3.2" },
						new DataItem() { Text = "Child 3.3" }
					}
			});

			treeView.ItemsSource = items;

			// This should not normally be done. In this demo it saves us creating and extra class/
			dropDownButton.DataContext = this;

			SelectedItem = items[0].Children[1];


		}


		private DataItem selectedItem;
		/// <summary>
		///     Gets or sets the name.
		/// </summary>
		public DataItem SelectedItem
		{
			get
			{
				return this.selectedItem;
			}
			internal set
			{
				if (this.selectedItem != value)
				{
					this.selectedItem = value;
					OnPropertyChanged("SelectedItem");
				}
			}
		}


		/// <summary>
		///     Event for INotifyPropertyChanged.
		/// </summary>
		public event PropertyChangedEventHandler PropertyChanged;

		/// <summary>
		///     Raises the INotifyPropertyChanged event.
		/// </summary>
		/// <param name="propertyName">The property to be included in the INotifyPropertyChanged EventArgs.</param>
		protected virtual void OnPropertyChanged(String propertyName)
		{
			if (PropertyChanged != null)
			{
				PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
			}
		}

		int counter;

		private void Button_Click(object sender, System.Windows.RoutedEventArgs e)
		{
			var itemToSelect = items[0].Children[2];
			dropDownButton.Content = itemToSelect;
		}

		private void treeView_PreviewSelectionChanged(object sender, Telerik.Windows.Controls.SelectionChangedEventArgs e)
		{
			if (e.AddedItems != null && e.AddedItems.Count == 1)
			{
				var item = e.AddedItems[0] as DataItem;
				if (item != null && item.Children.Count > 0)
				{
					e.Handled = true;
				}
			}
		}
	}
}